
!RBProgramNodeVisitor methodsFor: '*AST-interpreter-Semantic-Binding' stamp: 'CamilloBruni 12/15/2011 14:24'!
acceptArgumentNode: anArgumentNode
	^ self acceptVariableNode: anArgumentNode! !

!RBProgramNodeVisitor methodsFor: '*AST-interpreter-Semantic-Binding' stamp: 'CamilloBruni 12/5/2011 19:21'!
acceptSelfNode: aSelfNode
	^ self acceptVariableNode: aSelfNode! !

!RBProgramNodeVisitor methodsFor: '*AST-interpreter-Semantic-Binding' stamp: 'CamilloBruni 12/5/2011 19:28'!
acceptSuperNode: aSuperNode
	^ self acceptVariableNode: aSuperNode! !

!RBProgramNodeVisitor methodsFor: '*AST-interpreter-Semantic-Binding' stamp: 'CamilloBruni 12/15/2011 14:24'!
acceptTemporaryNode: anTemporaryNode
	^ self acceptVariableNode: anTemporaryNode! !

!RBProgramNodeVisitor methodsFor: '*AST-interpreter-Semantic-Binding' stamp: 'CamilloBruni 12/8/2011 15:27'!
acceptThisContextNode: aThisContextNode
	^ self acceptVariableNode: aThisContextNode! !

!RBInstanceBinding methodsFor: '*AST-Interpreter-Semantic-Binding' stamp: 'CamilloBruni 12/5/2011 15:18'!
accept: aVisitor assign: aValue
	^ aVisitor write: aValue at: index named: name! !

!RBInstanceBinding methodsFor: '*AST-Interpreter-Semantic-Binding' stamp: 'CamilloBruni 12/5/2011 15:22'!
readWith: aVisitor
	^ aVisitor readInstVarAt: index named: name! !

!RBArgumentBinding methodsFor: '*AST-Interpreter-Semantic-Binding' stamp: 'CamilloBruni 12/9/2011 20:00'!
readWith: anInterpreter
	| index | 
	index := self scope node argumentNames indexOf: node name.
	^ anInterpreter readArgumentAt: index node: node! !

!RBVariableBinding methodsFor: '*AST-Interpreter-Semantic-Binding' stamp: 'CamilloBruni 12/5/2011 15:05'!
isArgument
	^ self isArgumentBinding! !

!RBVariableBinding methodsFor: '*AST-Interpreter-Semantic-Binding' stamp: 'CamilloBruni 12/5/2011 15:05'!
isContext
	^ self isContextBinding! !

!RBVariableBinding methodsFor: '*AST-Interpreter-Semantic-Binding' stamp: 'CamilloBruni 12/5/2011 15:05'!
isInstance
	^ self isInstanceBinding! !

!RBVariableBinding methodsFor: '*AST-Interpreter-Semantic-Binding' stamp: 'CamilloBruni 12/5/2011 15:06'!
isLiteral
	^ self isLiteralBinding! !

!RBVariableBinding methodsFor: '*AST-Interpreter-Semantic-Binding' stamp: 'CamilloBruni 12/5/2011 15:06'!
isSelf
	^ self isSelf! !

!RBVariableBinding methodsFor: '*AST-Interpreter-Semantic-Binding' stamp: 'CamilloBruni 12/5/2011 15:06'!
isSuper
	^ self isSuperBinding! !

!RBVariableBinding methodsFor: '*AST-Interpreter-Semantic-Binding' stamp: 'CamilloBruni 12/5/2011 15:06'!
isTemp
	^ self isTemporaryBinding! !

!RBVariableBinding methodsFor: '*AST-Interpreter-Semantic-Binding' stamp: 'CamilloBruni 12/5/2011 15:06'!
isUndeclared
	^ self isUndeclaredBinding! !

!RBVariableNode class methodsFor: '*AST-Interpreter-Semantic-Binding' stamp: 'CamilloBruni 8/30/2011 17:22'!
identifierToken: anIdentifierToken 
	anIdentifierToken value = 'self'
		ifTrue: [ ^ RBSelfNode withToken: anIdentifierToken ].
	anIdentifierToken value = 'thisContext'
		ifTrue: [ ^ RBThisContextNode withToken: anIdentifierToken ].
	anIdentifierToken value = 'super'
		ifTrue: [ ^ RBSuperNode withToken: anIdentifierToken ].
	^ self withToken: anIdentifierToken! !

!RBVariableNode class methodsFor: '*AST-Interpreter-Semantic-Binding' stamp: 'CamilloBruni 12/5/2011 19:19'!
withToken: anIdentifierToken
	^(self new)
		identifierToken: anIdentifierToken;
		yourself! !

!RBTemporaryBinding methodsFor: '*AST-Interpreter-Semantic-Binding' stamp: 'CamilloBruni 12/5/2011 18:36'!
accept: anInterpeter assign: value
	self flag: ' for now we rely on the temporaries being dicts'.
	^ anInterpeter write: value temporaryAt: -1 named: node name! !

!RBTemporaryBinding methodsFor: '*AST-Interpreter-Semantic-Binding' stamp: 'CamilloBruni 12/5/2011 18:46'!
readWith: anInterpreter
	self flag: ' for now we rely on the temporaries being dicts'.
	^ anInterpreter readTemporaryAt: -1 named: node name! !

!RBLiteralBinding methodsFor: '*AST-Interpreter-Semantic-Binding' stamp: 'CamilloBruni 12/5/2011 16:02'!
readWith: anInterpreter
	self flag: 'maybe introduce indirections over the interpreter'.
	^ self value! !

!RBLiteralBinding methodsFor: '*AST-Interpreter-Semantic-Binding' stamp: 'CamilloBruni 12/5/2011 15:11'!
value
	^ self binding value! !
